// Program for testing random numbers

#include <dssl.h>

int main()
{
    Random r;
    const int n_bin = 1000;
    int bin[n_bin];
    for (int i=0; i<n_bin; i++)
        bin[i] = 0;

    for (i=0; i<1000000; i++)
    {
        double val = r.Uniform();
        int j = int(val*n_bin);
        assert(0 <= j && j < n_bin);
        bin[j]++;
    }

    printf("Bin, Count\n");
    for (i=0; i<n_bin; i++)
        printf("%4d, %d\n", i, bin[i]);

    const int n_gauss = 100000;
    double g[n_gauss], sum = 0;
    for (i=0; i<n_gauss; i++)
    {
        g[i] = r.Normal();
        sum += g[i];
    }

    double mean = sum / n_gauss;

    double dev_sq = 0;
    for (i=0; i<n_gauss; i++)
        dev_sq += pow(g[i]-mean, 2);

    double sigma = sqrt(dev_sq/n_gauss);

    printf("Mean: %lf; Sigma: %lf\n", mean, sigma);

    return 0;
}
